<?php

include_once '../sys/inc/start.php';
include_once COMPRESS;
include_once SESS;
include_once '../sys/inc/home.php';
include_once SETTINGS;
include_once DB_CONNECT;
include_once IPUA;
include_once FNC;
include_once ADM_CHECK;
include_once USER;

user_access('adm_themes', null, 'index.php?' . SID);

adm_check();

include_once '../sys/inc/zip.php';

$set['title'] = 'Установка тем';

include_once THEAD;

title();

if (isset($_FILES['file']) && filesize($_FILES['file']['tmp_name']) != 0) {
    $file = esc(stripcslashes(htmlspecialchars($_FILES['file']['name'])));
    $file = preg_replace('#(|\?)#', NULL, $file);
    $name = esc(trim(retranslit(preg_replace('#\.[^\.]*$#', NULL, $file)))); // имя файла без расширения
    $ras = strtolower(preg_replace('#^.*\.#i', NULL, $file));

    if ($ras != 'zip') {
        $err = 'Тема должна находиться в ZIP архиве';
    }

    if (!isset($err)) {
        $zip = new PclZip($_FILES['file']['tmp_name']);
        $them_default = new PclZip(H . 'sys/add/them.zip');
        $content = $zip->extract(PCLZIP_OPT_BY_NAME, 'them.name', PCLZIP_OPT_EXTRACT_AS_STRING);
        $them_name = trim(esc(@$content[0]['content']));

        if (strlen2($them_name) == null) {
            $err = 'Файл "them.name" пуст или не найден';
        }

        $content = $zip->extract(PCLZIP_OPT_BY_NAME, 'style.css', PCLZIP_OPT_EXTRACT_AS_STRING);
        $css = trim(esc(@$content[0]['content']));

        if (strlen2($them_name) == null) {
            $err = 'Файл "style.css" пуст или не найден';
        }

        @mkdir(H . 'style/themes/' . $name, 0777);
        @chmod(H . 'style/themes/' . $name, 0777);

        if ($name != NULL) {
            @delete_dir(PCLZIP_OPT_PATH, H . 'style/themes/' . $name);
        }

        $zip->extract(PCLZIP_OPT_PATH, H . 'style/themes/' . $name, PCLZIP_OPT_SET_CHMOD, 0777, PCLZIP_OPT_BY_PREG, "#^[^\.ht]+#ui");
    } else {
        $err = 'Невозможно создать папку с темой';
    }

    if (!isset($err)) {
        msg('Тема "' . $name . ' (' . $them_name . ')" успешно установлена');
    }
}

err();
aut();

echo "<div class='list-group'>";
echo "<form class='list-group-item' enctype=\"multipart/form-data\" action='?' method=\"post\">";
echo "<div class='mb-3'>";
echo "<label>Выгрузить:</label>\n";
echo "<input name='file' class='form-control' type='file' accept='application/zip' />\n";
echo "</div>";
echo "<button type='submit' class='btn btn-success'>Далее</button>\n";
echo "</form>";

echo "<div class='list-group-item list-group-item-warning'>";
echo "<i class='mdi mdi-folder-zip-outline'></i> Тема должна находится в zip архиве без папки<br />\n";
echo "<i class='mdi mdi-file'></i> Присутствие файлов them.name и style.css обязательно<br />\n";
echo "<i class='mdi mdi-folder-edit-outline'></i> Название папки темы будет взято из названия архива<br />\n";
echo "</div>";

echo "<div class='list-group-item'>\n";
echo "<a href='themes.php'><i class='mdi mdi-palette'></i> Темы оформления</a>\n";
echo "</div>\n";

if (user_access('adm_panel_show')) {
    echo "<div class='list-group-item list-group-item-light'>\n";
    echo "<a href='/adm_panel/'><i class='mdi mdi-arrow-left'></i> Панель управления</a>\n";
    echo "</div>\n";
}

echo "</div>\n";

include_once TFOOT;
?>