<?php

include_once '../sys/inc/start.php';
include_once COMPRESS;
include_once SESS;
include_once '../sys/inc/home.php';
include_once SETTINGS;
include_once DB_CONNECT;
include_once IPUA;
include_once FNC;
include_once USER;

user_access('adm_news', null, 'index.php?' . SID);

// Переменные по умолчанию
if (isset($_POST['view'])) {
    $news['title'] = $_POST['title'];
    $news['msg'] = $_POST['msg'];
    $news['link'] = $_POST['link'];
    $news['id_user'] = $user['id'];
} else {
    $news['title'] = null;
    $news['msg'] = null;
    $news['link'] = null;
    $news['id_user'] = null;
}

if (isset($_POST['title']) && isset($_POST['msg']) && isset($_POST['link']) && isset($_POST['ok'])) {
    $title = esc($_POST['title'], 1);
    $link = esc($_POST['link'], 1);
    $msg = esc($_POST['msg'], 1);

    if ($link != NULL && !preg_match('#^https?://#', $link) && !preg_match('#^/#i', $link)) {
        $link = '/' . $link;
    }

    if (strlen2($title) > 50) {
        $err = 'Слишком большой заголовок новости';
    }
    if (strlen2($title) < 3) {
        $err = 'Короткий заголовок';
    }

    $mat = antimat($title);

    if ($mat) {
        $err[] = 'В заголовке новости обнаружен мат: ' . $mat;
    }

    if (strlen2($msg) > 10024) {
        $err = 'Содержиние новости слишком большое';
    }
    if (strlen2($msg) < 2) {
        $err = 'Новость слишком короткая';
    }

    $mat = antimat($msg);

    if ($mat) {
        $err[] = 'В содержании обнаружен мат: ' . $mat;
    }

    $title = my_esc($_POST['title']);
    $msg = my_esc($_POST['msg']);

    if (!isset($err)) {
        $ch = intval($_POST['ch']);
        $mn = intval($_POST['mn']);
        $main_time = time() + $ch * $mn * 60 * 60 * 24;

        if ($main_time <= time()) {
            $main_time = 0;
        }

        dbquery("INSERT INTO `news` (`id_user`,`time`, `msg`, `title`, `main_time`, `link`) values('" . $user['id'] . "','$time', '" . $msg . "', '$title', '$main_time', '$link')");
        dbquery("update `user` set `news_read` = '0'");

        $news['id'] = mysql_insert_id();

        dbquery("OPTIMIZE TABLE `news`");
        dbquery("UPDATE `user` SET `news_read` = '0'");

        if (isset($_POST['mail'])) { // Расслылка новостей на майл
            $q = dbquery("SELECT `ank_mail` FROM `user` WHERE `set_news_to_mail` = '1' AND `ank_mail` <> ''");
            while ($ank = dbassoc($q)) {
                dbquery("INSERT INTO `mail_to_send` (`mail`, `them`, `msg`) values('$ank[ank_mail]', 'Новости', '" . trim(br(bbcode(links(stripcslashes(htmlspecialchars($msg)))))) . "')");
            }
        }

        $_SESSION['message'] = 'Новость успешно создана';
        header("Location: news.php?id=$news[id]");
        exit;
    }
}

$set['title'] = 'Создание новости';
include_once THEAD;

title();
err();
aut(); // форма авторизации

echo '<div class="list-group">';

echo '<form class="list-group-item" method="post" name="message" action="add.php">';
echo "<div class='mb-3'>";
echo '<label class="form-label">Заголовок новости:</label>';
echo '<input name="title" required size="16" maxlength="32" class="form-control" value="" type="text" />';
echo '</div>';

$msg2 = text($news['msg']);

echo "<div class='mb-3'>";
echo '<label class="form-label">Сообщение:' . $tPanel . '</label>';
echo '<textarea name="msg" required class="form-control"></textarea>';
echo '</div>';

echo "<div class='mb-3'>";
echo '<label class="form-label">Источник:</label>';
echo '<input name="link" size="16" class="form-control" maxlength="64" value="' . text($news['link']) . '" type="text" />';
echo '</div>';

echo "<div class='mb-3'>";
echo '<label class="form-label">Показывать на главной:</label>';
echo '<div class="input-group mb-3">';
echo '<input type="text" name="ch" size="3" class="form-control" value="' . (isset($_POST['ch']) ? "" . intval($_POST['ch']) . "" : "1") . '" />';
echo '<select name="mn" class="form-control">';
echo '<option value="0" ' . (isset($_POST['mn']) && $_POST['mn'] == 0 ? "selected='selected'" : null) . '>Не показывать</option>';
echo '<option value="1" ' . (isset($_POST['mn']) && $_POST['mn'] == 1 ? "selected='selected'" : null) . '>Дней</option>';
echo '<option value="7" ' . (isset($_POST['mn']) && $_POST['mn'] == 7 ? "selected='selected'" : null) . '>Недель</option>';
echo '<option value="31" ' . (isset($_POST['mn']) && $_POST['mn'] == 31 ? "selected='selected'" : null) . '>Месяцев</option>';
echo '</select>';
echo '</div>';
echo '</div>';

echo "<button class='btn btn-success' name='ok'><i class='mdi mdi-check icon'></i> Опубликовать</button>\n";

echo '</form>';

echo '<div class="list-group-item">';
echo '<a href="index.php"><i class="mdi mdi-arrow-left"></i> Новости</a><br />';
echo '</div>';
echo '</div>';

include_once TFOOT;
?>